Package org.apache.struts2.components

# Class MergeIterator

java.lang.Object
org.apache.struts2.components.Component
org.apache.struts2.components.ContextBean
org.apache.struts2.components.MergeIterator

All Implemented Interfaces:
  `Param.UnnamedParametric`

public class MergeIterator extends ContextBean implements Param.UnnamedParametric

Component for MergeIteratorTag, which job is to merge iterators and successive call to the merged iterator will cause each merge iterator to have a chance to expose its element, subsequently next call will allow the next iterator to expose its element. Once the last iterator is done exposing its element, the first iterator is allowed to do so again (unless it is exhausted of entries).

Internally the task are delegated to MergeIteratorFilter

Example if there are 3 lists being merged, each list have 3 entries, the following will be the logic.

1. Display first element of the first list
2. Display first element of the second list
3. Display first element of the third list
4. Display second element of the first list
5. Display second element of the second list
6. Display second element of the third list
7. Display third element of the first list
8. Display thrid element of the second list
9. Display third element of the thrid list

- var (String) - the name where the resultant merged iterator will be stored in the stack's context

public class MergeIteratorTagAction extends ActionSupport {

private List myList1; private List myList2; private List myList3;

public List getMyList1() { return myList1; }

public List getMyList2() { return myList2; }

public List getMyList3() { return myList3; }

public String execute() throws Exception {

myList1 = new ArrayList(); myList1.add("1"); myList1.add("2"); myList1.add("3");

myList2 = new ArrayList(); myList2.add("a"); myList2.add("b"); myList2.add("c");

myList3 = new ArrayList(); myList3.add("A"); myList3.add("B"); myList3.add("C");

return "done"; } }

<s:merge var="myMergedIterator1"> <s:param value="%{myList1}" /> <s:param value="%{myList2}" /> <s:param value="%{myList3}" /> </s:merge> <s:iterator value="%{#myMergedIterator1}"> <s:property /> </s:iterator>

This wil generate "1aA2bB3cC".

See Also:
  - `MergeIteratorFilter`
  - `MergeIteratorTag`

- ## Field Summary

  ### Fields inherited from class org.apache.struts2.components.ContextBean

  `var`

  ### Fields inherited from class org.apache.struts2.components.Component

  `actionMapper, attributes, COMPONENT_STACK, devMode, escapeHtmlBody, performClearTagStateForTagPoolingServers, stack, standardAttributesMap, throwExceptionOnELFailure`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MergeIterator(ValueStack stack)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addParameter(Object value)`
  Adds the given value as a parameter to the outer tag.
  `boolean`
  `end(Writer writer, String body)`
  Callback for the end tag of this component.
  `void`
  `setVar(String var)`
  `boolean`
  `start(Writer writer)`
  Callback for the start tag of this component.

  ### Methods inherited from class org.apache.struts2.components.ContextBean

  `getVar, putInContext`

  ### Methods inherited from class org.apache.struts2.components.Component

  `addAllAttributes, addParameter, completeExpression, copyAttributes, determineActionURL, determineNamespace, end, escapeHtmlBody, fieldError, findAncestor, findString, findString, findValue, findValue, findValue, getAttributes, getComponentStack, getNamespace, getPerformClearTagStateForTagPoolingServers, getStack, getStandardAttributes, isAcceptableExpression, isValidTagAttribute, popComponentStack, setActionMapper, setDevMode, setEscapeHtmlBody, setNotExcludedAcceptedPatterns, setPerformClearTagStateForTagPoolingServers, setThrowExceptionsOnELFailure, setUrlHelper, stripExpression, toString, usesBody`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### MergeIterator

    public MergeIterator(ValueStack stack)

- ## Method Details

  - ### start

    public boolean start(Writer writer)
    Description copied from class: `Component`
    Callback for the start tag of this component. Should the body be evaluated?
    Overrides:
      `start` in class `Component`
    Parameters:
      `writer` - the output writer.
    Returns:
      true if the body should be evaluated

  - ### end

    public boolean end(Writer writer, String body)
    Description copied from class: `Component`
    Callback for the end tag of this component. Should the body be evaluated again?
    NOTE: will pop component stack.
    Overrides:
      `end` in class `Component`
    Parameters:
      `writer` - the output writer.
      `body` - the rendered body.
    Returns:
      true if the body should be evaluated again

  - ### setVar

    public void setVar(String var)
    Overrides:
      `setVar` in class `ContextBean`

  - ### addParameter

    public void addParameter(Object value)
    Description copied from interface: `Param.UnnamedParametric`
    Adds the given value as a parameter to the outer tag.
    Specified by:
      `addParameter` in interface `Param.UnnamedParametric`
    Parameters:
      `value` - the value